SystemOrganization addCategory: #'OB-Web-Core'!
SystemOrganization addCategory: #'OB-Web-Widgets'!

OBInteractionRequest subclass: #OBAjaxResponse
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBAjaxResponse class methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 22:39'!
message: aMessage
	^ self basicNew setMessage: aMessage! !

!OBAjaxResponse methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 22:57'!
handleWith: anObject
	^ anObject handleAjaxResponse: self! !

!OBAjaxResponse methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2006 20:56'!
message
	^ message! !

!OBAjaxResponse methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 22:37'!
setMessage: anAjaxMessage
	message _ anAjaxMessage! !

Object subclass: #OBAjaxMessage
	instanceVariableNames: 'receiver selector arguments priority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBAjaxMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 20:25'!
fromJson: aJsonObject
	^ self
		receiver: aJsonObject receiver
		selector: aJsonObject selector asSymbol
		arguments: aJsonObject arguments! !

!OBAjaxMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 21:01'!
fromString: aString
	^ self fromJson: (Json readFrom: aString readStream)! !

!OBAjaxMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 10/27/2006 00:28'!
receiver: aString
	^ self basicNew receiver: aString! !

!OBAjaxMessage class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 20:29'!
receiver: receiver selector: selector arguments: arguments
	^ self new 
		setReceiver: receiver 
		selector: selector 
		arguments: arguments! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 6/18/2007 21:10'!
addArgument: anObject
	arguments ifNil: [arguments _ #()].
	arguments _ arguments copyWith: anObject.! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 5/21/2007 00:08'!
arguments
	^ arguments value! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 10/27/2006 00:29'!
arguments: anArray
	arguments _ anArray! !

!OBAjaxMessage methodsFor: 'receiving' stamp: 'cwp 10/25/2006 20:37'!
isAddressedTo: aWidget
	^ aWidget identifier = receiver! !

!OBAjaxMessage methodsFor: 'sending' stamp: 'cwp 5/21/2007 00:02'!
isDuplicateOf: other
	^ self receiver = other receiver
		and: [self selector = other selector]! !

!OBAjaxMessage methodsFor: 'sending' stamp: 'cwp 5/21/2007 00:08'!
jsonWriteOn: aStream
	aStream 
		nextPut: ${;
		jsonPrint: 'receiver';
		nextPut: $:;
		jsonPrint: self receiver;
		nextPutAll: ', ';
		jsonPrint: 'selector';
		nextPut: $:;
		jsonPrint: self selector;
		nextPutAll: ', ';
		jsonPrint: 'arguments';
		nextPut: $:;
		jsonPrint: self arguments;
		nextPut: $}! !

!OBAjaxMessage methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 21:25'!
log
	Transcript cr.
	self jsonWriteOn: Transcript.
	Transcript cr.
	Transcript endEntry.! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 5/27/2007 22:41'!
priority
	^ priority ifNil: [0]! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 5/27/2007 22:41'!
priority: anInteger
	priority _ anInteger! !

!OBAjaxMessage methodsFor: 'sending' stamp: 'cwp 10/26/2006 19:25'!
queue
	(OBAjaxResponse message: self) signal! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 5/21/2007 00:03'!
receiver
	^ receiver! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 10/27/2006 00:29'!
receiver: anObject
	receiver _ anObject! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 10/25/2006 21:34'!
selector
	^ selector! !

!OBAjaxMessage methodsFor: 'accessing' stamp: 'cwp 10/27/2006 00:29'!
selector: aSymbol
	selector _ aSymbol! !

!OBAjaxMessage methodsFor: 'receiving' stamp: 'cwp 10/25/2006 21:11'!
sendTo: aWidget
	^ aWidget perform: selector withArguments: arguments! !

!OBAjaxMessage methodsFor: 'initialize-release' stamp: 'cwp 10/25/2006 21:34'!
setReceiver: aString selector: aSymbol arguments: anArray
	receiver _ aString.
	selector _ aSymbol.
	arguments _ anArray! !

Object subclass: #OBSubcomputation
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBSubcomputation class methodsFor: 'as yet unclassified' stamp: 'cwp 2/11/2007 14:08'!
do: aBlock
	^ aBlock value: (self withContext: thisContext sender)! !

!OBSubcomputation class methodsFor: 'as yet unclassified' stamp: 'cwp 2/11/2007 11:17'!
withContext: anActivationContext
	^ self new initializeWithContext: anActivationContext! !

!OBSubcomputation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:39'!
callWithCurrentSubcontinuation: aBlock
	^ aBlock value: (OBSubcontinuation from: thisContext sender to: context)! !

!OBSubcomputation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:39'!
callcs: aBlock
	^ aBlock value: (OBSubcontinuation from: thisContext sender to: context)! !

!OBSubcomputation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:40'!
escape: aBlock
	|  continuation |
	continuation _ OBSubcontinuation from: thisContext sender to: context.
	thisContext swapSender: context.
	^ aBlock value: continuation! !

!OBSubcomputation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:40'!
initializeWithContext: anActivationContext
	context _ anActivationContext! !

!OBSubcomputation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:40'!
terminate: v
	| frame |
	frame _ thisContext sender.
	[frame == context] whileFalse: [frame _ frame swapSender: nil].
	thisContext swapSender: context.
	^ v
! !

Object subclass: #OBSubcontinuation
	instanceVariableNames: 'joinPoint values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBSubcontinuation class methodsFor: 'as yet unclassified' stamp: 'cwp 2/11/2007 11:21'!
from: start to: end
	^ self basicNew initializeFrom: start to: end! !

!OBSubcontinuation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:09'!
initializeFrom: start to: end
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ start.
	[context ~~ end and: [context notNil]] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context size do: [:i | valueStream nextPut: (context at: i)].
		joinPoint _ context.
		context _ context sender].
	values _ valueStream contents.
	! !

!OBSubcontinuation methodsFor: 'as yet unclassified' stamp: 'cwp 2/11/2007 11:45'!
joinPoint
	^ joinPoint! !

!OBSubcontinuation methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2007 23:23'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context size do: [:i | context at: i put: valueStream next]]! !

!OBSubcontinuation methodsFor: 'as yet unclassified' stamp: 'cwp 2/11/2007 13:13'!
value: v
	self restoreValues.
	joinPoint swapSender: thisContext sender.
	thisContext swapSender: values first.
	^ v! !

Object subclass: #OBWebLauncher
	instanceVariableNames: 'id queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 01:12'!
allowedSelectors
	^ #(openBrowser close)! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 01:12'!
close
	OBCloseWindowRequest for: self! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 23:27'!
flushQueue
	| tmp |
	tmp _ queue asArray.
	queue _ OrderedCollection new.
	^ tmp! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 22:40'!
html
	^ '<html>
<head>
	<title>launcher</title>
	<script src="http://localhost/ob/link.js"></script>
	<script src="http://localhost/ob/launcher.js"></script>
</head>
<body onload="initialize()">
	<div id="id1">
		<a href="javascript:launcher.openBrowser()">open browser</a>
	</div>
	<script>
		function initialize()
		{
			link = new Link(window.location);
			launcher = new Launcher("id1");
		}
	</script>
</body>
</html>
'! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:19'!
id
	^ id! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:19'!
identifier
	^ id asString! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:16'!
initialResponse
	^ HttpResponse fromUrl: self path! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 22:16'!
initialize
	id _ UUID new.
	queue _ OrderedCollection new.! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 00:07'!
openBrowser
	| window |
	window _ OBOpenWindowRequest for: OBSystemBrowser new.
	self queueMessage: (JsonObject new
							receiver: 'id1';
							selector: 'openWindow';
							arguments: {window path};
							yourself)! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:16'!
path
	^ id asString copyWithFirst: $/! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 23:29'!
processMessage: aMessage
	(self allowedSelectors includes: aMessage selector)
		ifTrue: [aMessage sendTo: self]
		ifFalse: [self webDoesNotUnderstand: aMessage].
	^ self flushQueue! !

!OBWebLauncher methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 22:17'!
queueMessage: aMessageSend
	queue add: aMessageSend! !

Object subclass: #OBWebMenuItem
	instanceVariableNames: 'label target selector arguments isEnabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebMenuItem class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2007 23:54'!
label: aString target: anObject selector: aSymbol 
	^ self label: aString target: anObject selector: aSymbol arguments: Array new.! !

!OBWebMenuItem class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2007 23:54'!
label: aString target: anObject selector: aSymbol arguments: anArray
	^ self basicNew setLabel: aString target: anObject selector: aSymbol arguments: anArray.! !

!OBWebMenuItem class methodsFor: 'as yet unclassified' stamp: 'cwp 6/11/2007 00:48'!
label: aString target: anObject selector: aSymbol isEnabled: aBoolean
	^ (self basicNew setLabel: aString target: anObject selector: aSymbol arguments: Array new)
		isEnabled: aBoolean;
		yourself! !

!OBWebMenuItem methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2007 23:50'!
isEnabled: aBoolean
	isEnabled _ aBoolean! !

!OBWebMenuItem methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 00:29'!
jsonWriteOn: aStream
	aStream
		nextPut: ${;
		jsonPrint: 'label';
		nextPutAll: ': ';
		jsonPrint: label;
		nextPutAll: ', ';
		jsonPrint: 'isEnabled';
		nextPutAll: ': ';
		jsonPrint: isEnabled;
		nextPut: $}! !

!OBWebMenuItem methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 23:02'!
label
	^ label! !

!OBWebMenuItem methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2007 23:50'!
setLabel: aString target: anObject selector: aSymbol arguments: anArray
	label _ aString.
	target _ anObject.
	selector _ aSymbol.
	arguments _ anArray.
	isEnabled _ true.! !

!OBWebMenuItem methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 23:10'!
value
	target perform: selector withArguments: arguments! !

Object subclass: #OBWebWidget
	instanceVariableNames: 'id model children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebWidget subclass: #OBWebChoiceWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

OBWebChoiceWidget subclass: #OBWebButtonBar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebButtonBar methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:45'!
htmlClass
	^ 'ButtonBar vertical'! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:03'!
allowedSelectors
	^ #(select:)! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:03'!
jsInitializeSelfOn: aStream
	self jsWidgetAccessorOn: aStream.
	aStream 
		nextPutAll: '.update(';
		jsonPrint: self state;
		nextPutAll: ');'! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:04'!
list
	^ model list ! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:04'!
select: aString
	| index |
	index _ self list indexOf: aString.
	model selection: index.
	! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:04'!
selection
	| selection |
	selection _ model selection.
	^ selection = 0
		ifTrue: [nil]
		ifFalse: [selection - 1]! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:05'!
state
	^ JsonObject new
		items: self list;
		selection: self selection;
		yourself! !

!OBWebChoiceWidget methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 23:05'!
update: aSelector
	self sendUpdate! !

OBWebChoiceWidget subclass: #OBWebList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebList methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2007 01:04'!
allowedSelectors
	^ super allowedSelectors, #(openMenu)! !

!OBWebList methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:45'!
htmlClass
	^ 'List vertical'! !

!OBWebList methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 21:45'!
openMenu
	| menu |
	menu _ model menu: OBWebMenu new.
	self addChild: menu.
	self createMessage
		selector: #openMenu;
		arguments: (Array with: menu);
		queue! !

OBWebWidget subclass: #OBWebMenu
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebMenu class methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2007 00:36'!
seed: anInteger
	^ self basicNew initializeWithId: (OBWebIdentifier seed: anInteger)! !

!OBWebMenu methodsFor: 'building' stamp: 'cwp 5/24/2007 23:53'!
add: aString target: anObject selector: aSymbol
	items add: (OBWebMenuItem
					label: aString
					target: anObject
					selector: aSymbol)! !

!OBWebMenu methodsFor: 'building' stamp: 'cwp 6/11/2007 00:46'!
add: aString target: anObject selector: aSymbol enabled: aBoolean icon: ignored 
	items add: (OBWebMenuItem
				label: aString
				target: anObject
				selector: aSymbol
				isEnabled: aBoolean)! !

!OBWebMenu methodsFor: 'compatibility' stamp: 'cwp 5/24/2007 23:58'!
addBlankIconsIfNecessary: anObject
! !

!OBWebMenu methodsFor: 'compatibility' stamp: 'cwp 5/24/2007 23:59'!
addLine
	items add: nil! !

!OBWebMenu methodsFor: 'accessing' stamp: 'cwp 5/25/2007 22:59'!
allowedSelectors
	^ #(select:)! !

!OBWebMenu methodsFor: 'printing' stamp: 'cwp 5/25/2007 22:06'!
htmlTagOn: aStream
	! !

!OBWebMenu methodsFor: 'initialize-release' stamp: 'cwp 5/25/2007 22:02'!
initializeWithId: aWebId
	super initializeWithId: aWebId.
	items _ OrderedCollection new! !

!OBWebMenu methodsFor: 'building' stamp: 'cwp 5/24/2007 23:42'!
items
	^ items! !

!OBWebMenu methodsFor: 'printing' stamp: 'cwp 5/25/2007 00:48'!
jsonWriteOn: aStream
	JsonObject new
		id: id asString;
		items: items;
		jsonWriteOn: aStream! !

!OBWebMenu methodsFor: 'building' stamp: 'cwp 5/24/2007 23:56'!
lastItem
	^ items size >= 1 ifTrue: [items last]! !

!OBWebMenu methodsFor: 'callbacks' stamp: 'cwp 5/25/2007 23:03'!
select: aString
	| item |
	item _ items 
		detect: [:ea | ea ifNil: [false] ifNotNil: [ea label = aString]] 
		ifNone: [^ self].
	item value! !

OBWebWidget subclass: #OBWebPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebPane methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 00:46'!
asJson
	^ JsonObject new
		id: self identifier;
		list: children first identifier;
		buttons: children second identifier;
		show: model wantsButton;
		yourself! !

!OBWebPane methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:45'!
htmlClass
	^ 'Pane horizontal'! !

!OBWebPane methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2007 00:08'!
jsInitializeSelfOn: aStream
	self jsWidgetAccessorOn: aStream.
	model wantsButton
		ifTrue: [aStream nextPutAll: '.showSwitch();']
		ifFalse: [aStream nextPutAll: '.hideSwitch();']! !

!OBWebPane methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2007 00:15'!
state
	^ model wantsButton! !

!OBWebPane methodsFor: 'as yet unclassified' stamp: 'cwp 5/22/2007 00:14'!
update: aSelector
	aSelector = #switch ifTrue: [self sendUpdate]! !

OBWebWidget subclass: #OBWebScroller
	instanceVariableNames: 'sizing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 02:00'!
basicUpdateSizing
	model ifNil: [sizing := 1] ifNotNil: [sizing := model sizing]! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:44'!
htmlClass
	^ 'Scroller vertical'! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:28'!
htmlStyle
	^ 'top: 0%; height: 40%'! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 01:55'!
jsInitializeSelfOn: aStream
	self jsWidgetAccessorOn: aStream.
	aStream 
		nextPutAll: '.setSizing(';
		jsonPrint: model sizing;
		nextPutAll: ');'! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 00:42'!
pop: count
	count timesRepeat: [children removeLast].
	self sendPop: count! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 01:08'!
push: columns
	| pane |
	columns doWithIndex: 
		[:col :index | 
		pane _ OBWebBuilder build: col.
		self addChild: pane.
		self sendPush: pane priority: (columns size - index + 1)]! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 00:43'!
sendPop: count
	self createMessage
		selector: #pop;
		arguments: {count};
		queue! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 00:44'!
sendPush: aPane priority: anInteger
	self createMessage
		selector: #push;
		arguments: {aPane asJson};
		priority: anInteger;
		queue! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 01:59'!
sizing
	^ sizing ifNil: [self basicUpdateSizing]! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/27/2007 20:45'!
state
	^ children collect: [:ea | ea identifier]! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 01:57'!
update: aSymbol
	aSymbol = #columns ifTrue: [self updatePanes]! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 01:58'!
updatePanes
	| columns |
	columns _ model columns.
	columns size > children size
		ifTrue: [self push: (columns allButFirst: children size)]
		ifFalse: [columns size < children size
					ifTrue: [self pop: children size - columns size]].
	self updateSizing! !

!OBWebScroller methodsFor: 'as yet unclassified' stamp: 'cwp 5/28/2007 02:02'!
updateSizing
	| old |
	old _ sizing.
	self basicUpdateSizing.
	sizing = old ifFalse:
		[self createMessage
			selector: #setSizing;
			arguments: {sizing};
			queue]! !

OBWebWidget subclass: #OBWebText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebText methodsFor: 'view callbacks' stamp: 'cwp 6/13/2007 00:41'!
accept: aString
	text _ aString.
	model accept: text notifying: self.! !

!OBWebText methodsFor: 'accessing' stamp: 'cwp 6/17/2007 18:31'!
allowedSelectors
	^ #(accept: implementors: senders: references: browse:)! !

!OBWebText methodsFor: 'view callbacks' stamp: 'cwp 6/17/2007 18:33'!
browse: aString
	model browseIt: aString findSelector! !

!OBWebText methodsFor: 'accessing' stamp: 'cwp 10/25/2006 11:45'!
htmlClass
	^ 'Text vertical'! !

!OBWebText methodsFor: 'html' stamp: 'cwp 10/24/2006 15:31'!
htmlStyle
	^ 'top: 40%; height: 60%'! !

!OBWebText methodsFor: 'view callbacks' stamp: 'cwp 6/16/2007 23:56'!
implementors: aString
	model implementorsOfIt: aString findSelector! !

!OBWebText methodsFor: 'html' stamp: 'cwp 6/2/2007 02:02'!
jsInitializeSelfOn: aStream
	self jsWidgetAccessorOn: aStream.
	aStream 
		nextPutAll: '.init(';
		jsonPrint: self state;
		nextPutAll: ');'! !

!OBWebText methodsFor: 'model callbacks' stamp: 'cwp 6/13/2007 01:09'!
notify: aString at: anInteger in: aReadStream 
	text _ String streamContents:
			[:stream |
			1 to: anInteger - 1 do: [:i | stream nextPut: (text at: i)].
			stream nextPutAll: aString.
			anInteger to: text size do: [:i | stream nextPut: (text at: i)]].
	self sendUpdate! !

!OBWebText methodsFor: 'view callbacks' stamp: 'cwp 6/17/2007 18:32'!
references: aString
	model referencesToIt: aString findSelector! !

!OBWebText methodsFor: 'view callbacks' stamp: 'cwp 6/17/2007 18:32'!
senders: aString
	model sendersOfIt: aString findSelector! !

!OBWebText methodsFor: 'accessing' stamp: 'cwp 6/13/2007 23:23'!
state
	| bold |
	bold _ self text isText and: [(self text rangeOf: TextEmphasis bold startingAt: 1) size > 0].
	^ JsonObject new
		text: self text;
		bold: bold;
		yourself! !

!OBWebText methodsFor: 'model callbacks' stamp: 'cwp 6/13/2007 23:21'!
text
	^ text ifNil: ['']! !

!OBWebText methodsFor: 'accessing' stamp: 'cwp 6/13/2007 01:06'!
update: aSelector
	text _ model text.
	self sendUpdate! !

!OBWebWidget class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 14:44'!
id: aWebIdentifier model: anObject
	^ (self basicNew initializeWithId: aWebIdentifier)
		model: anObject;
		yourself! !

!OBWebWidget class methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 02:10'!
model: aBrowser
	^ self new model: aBrowser! !

!OBWebWidget class methodsFor: 'as yet unclassified' stamp: 'cwp 10/22/2006 02:10'!
new
	^ self basicNew initialize! !

!OBWebWidget methodsFor: 'children' stamp: 'cwp 10/25/2006 19:08'!
addAllChildrenTo: aDictionary
	children do: [:ea | ea addWithAllChildrenTo: aDictionary].
	^ aDictionary! !

!OBWebWidget methodsFor: 'children' stamp: 'cwp 10/22/2006 02:09'!
addChild: aWidget
	children add: aWidget! !

!OBWebWidget methodsFor: 'children' stamp: 'cwp 10/25/2006 19:08'!
addWithAllChildrenTo: aDictionary
	aDictionary at: self identifier put: self.
	^ self addAllChildrenTo: aDictionary.
	! !

!OBWebWidget methodsFor: 'children' stamp: 'cwp 10/25/2006 19:20'!
allChildren
	^ self addAllChildrenTo: (Dictionary new)! !

!OBWebWidget methodsFor: 'accessing' stamp: 'cwp 10/25/2006 21:38'!
allowedSelectors
	^ #()! !

!OBWebWidget methodsFor: 'children' stamp: 'cwp 10/22/2006 01:50'!
children
	^ children! !

!OBWebWidget methodsFor: 'accessing' stamp: 'cwp 10/27/2006 00:26'!
createMessage
	^ OBAjaxMessage receiver: self identifier! !

!OBWebWidget methodsFor: 'ajax' stamp: 'cwp 10/25/2006 18:57'!
handleMessage: message
	| selector |
	selector _ message selector asSymbol.
	^ (self allowedSelectors includes: selector)
		ifTrue: [self perform: selector withArguments: message arguments. true]
		ifFalse: [false]! !

!OBWebWidget methodsFor: 'html' stamp: 'cwp 10/24/2006 14:52'!
html
	^ String streamContents: [:s | self htmlOn: s]! !

!OBWebWidget methodsFor: 'html' stamp: 'cwp 10/24/2006 15:31'!
htmlStyle
	^ nil! !

!OBWebWidget methodsFor: 'html' stamp: 'cwp 10/24/2006 15:31'!
htmlTagOn: aStream
	aStream 
		nextPutAll: '<div id="';
		print: id;
		nextPutAll: '" class="';
		nextPutAll: self htmlClass;
		nextPut: $".
	self htmlStyle ifNotNilDo: 
		[:style | aStream
					nextPutAll: ' style="';
					nextPutAll: style;
					nextPut: $"].
	aStream nextPut: $>.
	children do: [:ea | ea htmlTagOn: aStream].
	aStream nextPutAll: '</div>'! !

!OBWebWidget methodsFor: 'accessing' stamp: 'cwp 10/22/2006 01:49'!
identifier
	^ id asString! !

!OBWebWidget methodsFor: 'initialize-release' stamp: 'cwp 10/24/2006 14:31'!
initialize
	self initializeWithId: (OBWebIdentifier new)! !

!OBWebWidget methodsFor: 'initialize-release' stamp: 'cwp 10/24/2006 14:30'!
initializeWithId: aWebIdentifier
	id _ aWebIdentifier.
	children _ OrderedCollection new.! !

!OBWebWidget methodsFor: 'html' stamp: 'cwp 6/12/2007 21:19'!
jsInitializeOn: aStream
	self jsInitializeSelfOn: aStream.
	aStream space.
	children 
		do: [:ea | ea jsInitializeOn: aStream]
		separatedBy: [aStream space]! !

!OBWebWidget methodsFor: 'html' stamp: 'cwp 5/21/2007 00:25'!
jsInitializeSelfOn: aStream
	! !

!OBWebWidget methodsFor: 'html' stamp: 'cwp 10/25/2006 12:03'!
jsWidgetAccessorOn: aStream
	aStream
		nextPutAll: 'Widget.get("';
		print: id;
		nextPutAll: '")'! !

!OBWebWidget methodsFor: 'accessing' stamp: 'cwp 10/22/2006 01:49'!
model
	^ model! !

!OBWebWidget methodsFor: 'accessing' stamp: 'cwp 10/25/2006 22:10'!
model: anObject
	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model _ anObject! !

!OBWebWidget methodsFor: 'initialize-release' stamp: 'cwp 10/25/2006 13:42'!
registerWith: aHttpService
	aHttpService addResponder: self.
	children do: [:ea | ea registerWith: aHttpService]! !

!OBWebWidget methodsFor: 'ajax' stamp: 'cwp 5/29/2007 23:02'!
sendUpdate
	self createMessage
		selector: #update;
		arguments: [Array with: self state];
		queue! !

!OBWebWidget methodsFor: 'accessing' stamp: 'cwp 10/27/2006 00:11'!
update: aSelector
	Transcript cr; show: self class name, ': ', aSelector! !

!OBWebWidget methodsFor: 'children' stamp: 'cwp 10/25/2006 19:20'!
withAllChildren
	^ self addWithAllChildrenTo: Dictionary new! !

OBWebWidget subclass: #OBWebWindow
	instanceVariableNames: 'queue continuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebWindow methodsFor: 'accessing' stamp: 'cwp 5/31/2007 00:16'!
allowedSelectors
	^ #(close)! !

!OBWebWindow methodsFor: 'callbacks' stamp: 'cwp 5/31/2007 00:08'!
close
	model windowIsClosing.
	OBCloseWindowRequest for: self! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 6/19/2007 00:27'!
deliverMessage: message
	| table receiver |
	table _ self withAllChildren.
	receiver _ table 
				detect: [:ea | message isAddressedTo: ea] 
				ifNone: [^ 'Unknown receiver'].
	[receiver handleMessage: message]
		on: OBInteractionRequest 
		do: [:response | response handleWith: self].
! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 6/19/2007 00:49'!
escape
	^ continuation escape: [:cc | continuation _ cc]
	! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 5/27/2007 22:49'!
flushQueue
	| tmp |
	tmp _ queue.
	self initializeQueue.
	^ tmp! !

!OBWebWindow methodsFor: 'notifications' stamp: 'cwp 5/27/2007 22:44'!
handleAjaxResponse: response
	self queueMessage: response message.
	response resume! !

!OBWebWindow methodsFor: 'notifications' stamp: 'cwp 5/31/2007 00:08'!
handleBrowseRequest: request
	| window |
	window _ OBOpenWindowRequest for: request browser.
	self queueMessage: (self createMessage
							selector: #openWindow;
							arguments: {window path})! !

!OBWebWindow methodsFor: 'notifications' stamp: 'cwp 6/19/2007 00:52'!
handleChoiceRequest: aRequest
	| message |
	message _ self createMessage.
	message
		selector: 'requestChoice';
		arguments: (Array with: aRequest prompt with: aRequest labels).
	self queueMessage: message.
	aRequest select: self escape.! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 5/31/2007 00:18'!
handleMessage: aMessage
	aMessage log.
	super handleMessage: aMessage! !

!OBWebWindow methodsFor: 'notifications' stamp: 'cwp 6/18/2007 21:06'!
handleTextRequest: aRequest
	
	| message |
	message _ self createMessage.
	message
		selector: 'requestText';
		arguments: (Array with: aRequest prompt with: aRequest template).
	self queueMessage: message resuming: aRequest.! !

!OBWebWindow methodsFor: 'accessing' stamp: 'cwp 10/27/2006 01:00'!
htmlClass
	^ 'Root root'! !

!OBWebWindow methodsFor: 'html' stamp: 'cwp 6/12/2007 21:26'!
htmlOn: aStream
	aStream nextPutAll: '<html><head><title>browser</title><script src="http://localhost/ob/link.js"></script><script src="http://localhost/ob/widgets.js"></script><link rel="stylesheet" href="http://localhost/ob/browser.css" type="text/css" /></head><body onload="onLoad()">'.
		self htmlTagOn: aStream.
	aStream nextPutAll: '<script>function onLoad() {'.
	self jsInitializeOn: aStream.
	aStream
		nextPutAll: '}</script>';
		nextPutAll: '</body></html>'
! !

!OBWebWindow methodsFor: 'initialize-release' stamp: 'cwp 5/27/2007 22:49'!
initializeQueue
	queue _ SortedCollection sortBlock: [:a :b | b priority <= a priority]! !

!OBWebWindow methodsFor: 'initialize-release' stamp: 'cwp 5/27/2007 22:48'!
initializeWithId: aWebIdentifier
	super initializeWithId: aWebIdentifier.
	self initializeQueue.! !

!OBWebWindow methodsFor: 'html' stamp: 'cwp 6/18/2007 18:53'!
jsInitializeSelfOn: aStream
	aStream 
		nextPutAll: 'Widget.init("';
		print: id;
		nextPutAll: '");'.
	! !

!OBWebWindow methodsFor: 'accessing' stamp: 'cwp 10/20/2006 00:32'!
path
	^ self identifier copyWithFirst: $/! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 6/19/2007 00:58'!
processMessage: message
	| k |
	OBSubcomputation do: 
		[:escape | 
		k _ continuation.
		continuation _ escape.
		message selector = #continue:
			ifTrue: [k value: message arguments first]
			ifFalse: [self deliverMessage: message]].
	^ self flushQueue! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 5/21/2007 00:01'!
queueMessage: anAjaxMessage
	(queue noneSatisfy: [:ea | anAjaxMessage isDuplicateOf: ea])
		ifTrue: [queue add: anAjaxMessage]! !

!OBWebWindow methodsFor: 'messaging' stamp: 'cwp 6/19/2007 00:36'!
queueMessage: anAjaxMessage resuming: aRequest
	| value |
	value _ continuation escape:
		[:cc |
		continuation _ cc.
		self queueMessage: anAjaxMessage].
	aRequest resume: value! !

!OBWebWindow methodsFor: 'accessing' stamp: 'cwp 10/27/2006 01:01'!
update: aSelector
	aSelector = #relabel
		ifTrue: [self createMessage
					selector: 'title';
					arguments: {model labelString};
					queue]! !

OBBuilder subclass: #OBWebBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBWebBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:42'!
build: aBrowser
	| builder |
	builder _ self new.
	aBrowser buildOn: builder.
	^ builder root! !

!OBWebBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 10/23/2006 14:55'!
new
	^ self basicNew initialize! !

!OBWebBuilder methodsFor: 'accessing' stamp: 'cwp 3/13/2007 22:54'!
addChild: anObject
	current _ anObject! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 3/16/2007 23:59'!
browser: aBrowser with: aBlock
	^ self 
		current: (OBWebWindow model: aBrowser)
		do: aBlock.
! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 5/21/2007 22:33'!
column: aColumn with: aBlock
	^ self
		current: (OBWebPane model: aColumn)
		do: [self current: (OBWebList model: aColumn) do: [].
			aBlock value]! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 3/17/2007 00:00'!
columnPanel: aColumnPanel with: aBlock 
	^ self
		current: (OBWebScroller model: aColumnPanel)
		do: aBlock! !

!OBWebBuilder methodsFor: 'accessing' stamp: 'cwp 3/17/2007 00:01'!
current: aWidget do: aBlock
	current addChild: aWidget.
	^ super current: aWidget do: aBlock! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 3/17/2007 00:00'!
definitionPanel: aPanel with: aBlock
	^ self 
		current: (OBWebText model: aPanel)
		do: aBlock! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 3/18/2007 23:26'!
fixedButtonPanel: aPanel with: aBlock! !

!OBWebBuilder methodsFor: 'initialize-release' stamp: 'cwp 3/16/2007 23:59'!
initialize
	current _ self! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 5/20/2007 23:01'!
mercuryPanel: aPanel with: aBlock
	! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 3/18/2007 23:25'!
panelGroup: aCollection with: aBlock
	aBlock value! !

!OBWebBuilder methodsFor: 'building' stamp: 'cwp 5/21/2007 22:24'!
switch: aSwitch with: aBlock
	^ self
		current: (OBWebButtonBar model: aSwitch)
		do: aBlock! !

HttpService subclass: #OBHttpService
	instanceVariableNames: 'windows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:06'!
createLauncher
	| launcher |
	launcher _ OBWebLauncher new.
	windows add: launcher.
	^ launcher initialResponse! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 11:42'!
createWindowFor: aBrowser
	| window |
	window _ OBWebBuilder build: aBrowser.
	windows add: window.
	^ window! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 00:31'!
destroyWindowFor: aWebWindow
	^ windows remove: aWebWindow! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 00:27'!
handleCloseWindow: req
	req resume: (self destroyWindowFor: req model)! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 00:28'!
handleOpenWindow: req
	req resume: (self createWindowFor: req model)! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 01:02'!
handleRequest: aRequest
	| response |
	response _ [(aRequest method = 'GET')
		ifTrue: [self processGet: aRequest]
		ifFalse: [self processPost: aRequest]]
			on: OBWindowRequest
			do: [:req | req handleWith: self].
	^ response! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:03'!
initialize
	super initialize.
	windows _ Set new! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/18/2006 18:02'!
notFound: aRequest
	^ HttpResponse 
		status: #notFound
		contents: aRequest url, ' was not found on this server'! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2006 20:48'!
processError: anError
	self halt.
	^ HttpResponse basicNew
		status: #serverError;
		contentType: MIMEDocument contentTypePlainText;
		contents: (anError class name, ': ', anError messageText) readStream;
		yourself! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/20/2006 00:15'!
processGet: aRequest
	
	aRequest url = '/' ifTrue: [^ self createLauncher].
	^ self 
		targetForRequest: aRequest
		ifPresent: [:target | target html]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/26/2006 22:19'!
processHttpRequest: aRequest
	^ [self handleRequest: aRequest]
		on: Error
		do: [:error | self processError: error]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 21:01'!
processPost: aRequest
	| message |
	message _ OBAjaxMessage fromString: aRequest rawPostFields.
	^ self 
		targetForRequest: aRequest
		ifPresent: [:target | Json render: (target processMessage: message)]! !

!OBHttpService methodsFor: 'as yet unclassified' stamp: 'cwp 5/21/2007 19:54'!
targetForRequest: aRequest ifPresent: aBlock
	| id target val type |
	id _ aRequest url allButFirst.
	target _ windows
				detect: [:ea | id = ea identifier]
				ifNone: [^ self notFound: aRequest].
	val _ aBlock value: target.
	type _ aRequest isGetRequest
		ifTrue: ['text/html']
		ifFalse: ['text/plain'].
	^ (HttpResponse fromString: val)
		contentType: type, '; charset=utf-8';
		yourself! !

LargePositiveInteger variableByteSubclass: #OBWebIdentifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Widgets'!

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:23'!
defaultSize
	^ 16! !

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:22'!
new
	^ self new: self defaultSize! !

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:22'!
random: aRandom
	^ (self basicNew: self defaultSize) initializeWithRandom: aRandom! !

!OBWebIdentifier class methodsFor: 'as yet unclassified' stamp: 'cwp 10/25/2006 13:51'!
seed: anInteger
	^ self random: (Random seed: anInteger)! !

!OBWebIdentifier methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:11'!
initialize
	self initializeWithRandom: Random new! !

!OBWebIdentifier methodsFor: 'as yet unclassified' stamp: 'cwp 10/24/2006 11:15'!
initializeWithRandom: aRandom
	1 to: self size do: [:i | self at: i put: (aRandom nextInt: 255)]! !

!OBWebIdentifier methodsFor: 'as yet unclassified' stamp: 'cwp 5/30/2007 00:11'!
printOn: aStream
	
	| base digits current i letters quo |
	base _ 36.
	digits _ '0123456789abcdefghijklmnopqrstuvwxyz'.
	current _ self.
	i _ self digitLength * 8.
	letters _ String new: i.
	[current < base] whileFalse: 
		[quo _ current quo: base.
		letters at: i put: (digits at: (current - (quo * base)) + 1).
		i _ i - 1.
		current _ quo].
	letters at: i put: (digits at: current + 1).
	aStream nextPut: $w.
	aStream nextPutAll: (letters copyFrom: i to: letters size)
	
! !

Notification subclass: #OBWindowRequest
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

OBWindowRequest subclass: #OBCloseWindowRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBCloseWindowRequest methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 00:27'!
handleWith: anObject
	^ anObject handleCloseWindow: self! !

OBWindowRequest subclass: #OBOpenWindowRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Web-Core'!

!OBOpenWindowRequest methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2007 00:27'!
handleWith: anObject
	^ anObject handleOpenWindow: self! !

!OBWindowRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 5/26/2007 00:14'!
for: anObject
	^ (self new model: anObject) signal! !

!OBWindowRequest methodsFor: 'as yet unclassified' stamp: 'cwp 5/26/2007 00:15'!
model
	^ model! !

!OBWindowRequest methodsFor: 'as yet unclassified' stamp: 'cwp 5/26/2007 00:15'!
model: anObject
	model _ anObject! !

!HttpRequest methodsFor: '*ob-web-accessing' stamp: 'cwp 10/19/2006 23:38'!
postData
	| rawPostFields |
	rawPostFields _ self rawPostFields.
	^ rawPostFields isEmpty
		ifTrue: [stream next: self contentLength]
		ifFalse: [rawPostFields]! !
